using System;
using System.Collections.Generic;
using System.Linq;

namespace Benday.CSharpNinja.WinUi.GenericsSamples
{
    public class DomainObjectManager<T> where T : IInt32Identity, new()
    {
        public T GetById(int id)
        {
            if (id < 1)
            {
                throw new InvalidOperationException("Invalid Id value.");
            }
            else
            {
                var dataAccess = new DataAccessManager<T>();

                return dataAccess.RetrieveFromDatabase(id);
            }
        }

        public void Save(T saveThis)
        {
            var dataAccess = new DataAccessManager<T>();

            dataAccess.SaveToDatabase(saveThis);
        }
    }
}
