using System;
using System.Collections.Generic;
using System.Linq;

namespace Benday.CSharpNinja.WinUi.LinqSamples
{
    public class LinqSample
    {
        public LinqSample()
        {
            Employees = new List<Employee>();

            Employees.Add(CreateEmployee(23, "Jimbo", "Rosenwinkle", 34523, "MA"));
            Employees.Add(CreateEmployee(24, "Simm", "Pullton", 1200000, "WA"));
            Employees.Add(CreateEmployee(25, "Bud", "Tuggley", 75000, "CT"));
            Employees.Add(CreateEmployee(26, "Gigi", "Burrenburg", 52000, "MA"));
            Employees.Add(CreateEmployee(27, "Lucy", "Burrenstein", 61500, "MA"));
        }

        public List<Employee> GetByState(string stateOfResidence)
        {
            IEnumerable<Employee> result =
                from temp in Employees
                where temp.StateOfResidence == stateOfResidence
                select temp;

            return result.ToList();
        }

        public Employee GetById(int id)
        {
            Employee match =
                (from temp in Employees
                 where temp.Id == id
                 select temp).FirstOrDefault();

            return match;
        }

        public IEnumerable<Employee> GetAllSortedByLastNameThenFirstName()
        {
            IEnumerable<Employee> result =
                from temp in Employees
                orderby temp.LastName, temp.FirstName
                select temp;

            return result;
        }

        private Employee CreateEmployee(int id,
            string firstName,
            string lastName,
            int salary,
            string stateOfResidence)
        {
            return new Employee()
            {
                Id = id,
                FirstName = firstName,
                LastName = lastName,
                Salary = salary,
                StateOfResidence = stateOfResidence
            };
        }

        public List<Employee> Employees { get; set; }

    }
}
